Imports System.Data.OleDb

'OLE DB ErrorCollection sample
Module ErrorCollection

    Public Sub Main()

        Dim i As Integer
        Dim con As OleDbConnection

        Try
            'Create new Connection
            Console.WriteLine("Create new connection")
            con = New OleDbConnection("Provider=LCPI.IBProvider;")

            Console.WriteLine("Trying open connection")
            con.Open()

        Catch myOLEDBException As OleDbException 'ole db exception
            'error collection sample 
            Console.WriteLine("----------------------------------------")
            For i = 0 To myOLEDBException.Errors.Count - 1
                Console.WriteLine("Message " & i.ToString + 1 & ": " + myOLEDBException.Errors(i).Message, True)
                Console.WriteLine("Native: " + myOLEDBException.Errors(i).NativeError.ToString())
                Console.WriteLine("Source: " + myOLEDBException.Errors(i).Source)
                Console.WriteLine("SQL: " + myOLEDBException.Errors(i).SQLState)
                Console.WriteLine("----------------------------------------")
            Next i

        Catch myException As Exception  'other exception
            'error collection sample
            Console.WriteLine("----------------------------------------")
            Console.WriteLine(myException.Message)
        End Try

        Console.WriteLine("Close connection if connection state is open", True)
        If con.State = ConnectionState.Open Then
            con.Close()
        End If

        Console.WriteLine("All Done. Press Enter to close", True)
        Console.ReadLine()

    End Sub

End Module
